package my.test;

import java.util.Properties;

import org.infinispan.client.hotrod.RemoteCache;
import org.infinispan.client.hotrod.RemoteCacheManager;
import org.infinispan.server.core.Main;
import org.infinispan.util.logging.Log;
import org.infinispan.util.logging.LogFactory;


public class Infinispan{
    
    private static final Log logger = LogFactory.getLog(Infinispan.class);
    private String namesToQuery[] = new String []{"Bart","Homer","Jean-Luc"};
    public static void main(String[] args) {
        new Infinispan().go(args);
    }
    private void go(String args[]){
        if("server".equals(args[0])){
            String ip = args[1];
            startServerOnIP(ip);
        }
        else if ("client".equals(args[0])){
            String ipServer1 = args[1];
            String ipServer2 = args[2];
            searchFirstname(ipServer1, ipServer2);
        }
    }
    private void searchFirstname(String ipServer1, String ipServer2) {
        RemoteCacheManager cacheContainer;
        Properties hotrodClientProperties = new Properties();
        StringBuffer serverList = new StringBuffer();
        serverList
            .append(ipServer1)
            .append(":11222")
            .append(";")
            .append(ipServer2)
            .append(":11222");
        hotrodClientProperties.setProperty("infinispan.client.hotrod.server_list", serverList.toString());
        cacheContainer = new RemoteCacheManager(hotrodClientProperties);
        RemoteCache<String, String> clientRemoteCache = cacheContainer.getCache("cache_characterNames");
        
        for (int i = 0; i < namesToQuery.length; i++) {
            Object value = clientRemoteCache.get(namesToQuery[i]);
            logger.info("------------------");
            logger.info("name queried:"+namesToQuery[i]);
            logger.info("value retrieved:"+value);
            logger.info("------------------");
        }
    }
    private void startServerOnIP(String ip) {
        System.setProperty("jgroups.tcp.address", ip);
        System.setProperty("jgroups.bind_addr", ip);
        String hotRodServerArgs[] = new String[]{"-r","hotrod","-c", "infinispan-config.xml","-l", ip};
        Main.main(hotRodServerArgs);
    }
}
